#!/bin/sh
# $Id: t-dbl-bounce-1.sh,v 1.5 2013/11/26 03:09:13 ca Exp $
# Copyright (c) 2011 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test endless loop
# uses smtp1.sh
# ----------------------------------------
#
test -s stop && exit 1
#

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

I=""
ERRS=0

if test X"`uname`" != "XOSF1"
then
while getopts f:s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to working directory for alias file!
cd ../qmgr || exit 1

# create aliases
${CAT} > ${ALI} <<EOF
abuse:	local:
postmaster:	local:
user:	local:
sender: local:
EOF
# create map
rm -f ${ALIMAP}
${MM} < ${ALI}
${CAT} > ${MTMAP} <<EOF
local.host	[127.0.0.1]
local.dom	[127.0.0.1]
.	[127.0.0.1]
EOF

# ----------------------------------------
# endless loop
TEST=1
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then

${CAT} > ${SMXCNF} <<EOF
qmgr { Log_Level = 12; wait_for_server=4; wait_for_client=4;
  DSN_handling { flags =  {MIME_format }; }
}
smar { Log_Level = 12; nameserver = ${NS}; }
smtpc { Log_Level = 12; remote_port=${SRVPORT}; wait_for_server=4;
  flags = { read_QUIT_reply, separate_final_dot_and_QUIT, talk_to_myself }
}
smtps { Log_Level = 14; daemon_address = localhost:${SRVPORT};
  flags = { -starttls }
  wait_for_server=4; }
EOF

ERR=false
if ${SHELL} ${SD}/smtpcnf.sh -3 lmtpsock -E 0 -A 1 -X 0 -S"sender@local.host" -Ruser@local.host -s 20
then
  if ${GREP} 'rcpt=<doublebounce@.*, stat=90$' ${SSL} >/dev/null
  then
    :
  else
    ${VERBOSE} && echo "$0: test ${TEST}: missing 'rcpt=<doublebounce@.*, stat=90$' in ${SSL}"
    ERR=true
  fi

else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
fi

# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  rm -f ${OK} ${OUT}
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
