#!/bin/sh
# $Id: t-qtmo-0.sh,v 1.3 2011/02/01 05:58:26 ca Exp $
# Copyright (c) 2010 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test QRET setting via MAIL extension
# ----------------------------------------

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

if test "X"${MTA_TIMING} = "X"
then
  echo "SKIPPED: $0: MTA_TIMING is not set"
  exit 0
fi

cd ../qmgr || exit 1

for P in smtps smtpc qmgr
do
  chkcto $P COMMERCIAL
  chkcto $P SMI_PRI
done

# create aliases
${CAT} > ${ALI} <<EOF
postmaster:	local:
user:	local:
EOF
# create map
rm -f ${ALIMAP}
${MM} < ${ALI}

# create mailertable (save old version?)
${CAT} > ${MT} <<EOF
local.dom	[127.0.0.1]
other.dom	[127.0.0.1]
EOF

# ----------------------------------------
TEST=1
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
if ${SHELL} ${SD}/smtp1.sh -Ssender@other.dom -R451@local.dom -Z smtpc2 -c '-M RMIN=1_RMAX=1_QRET=1' -s 200 -E 4
then
  :
else
  ERR=true
fi

if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
fi


# ----------------
if test ${ERRS} -eq 0
then
  rm -f ${EDBROK}
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
