#!/bin/sh
# $Id: t-verp-2.sh,v 1.4 2011/02/01 05:58:58 ca Exp $
#
# Copyright (c) 2010, 2011 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test VERP handling, options set in config file
# uses smtpcnf.sh.
# ----------------------------------------
#

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

for P in smtps smtpc qmgr
do
  chkcto $P COMMERCIAL
  chkcto $P SMI_MAILEXT
done

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to working directory for alias file!
cd ../qmgr || exit 1

# create aliases
${CAT} > ${ALI} <<EOF
abuse:	local:
postmaster:	local:
user:	local:
user++:	local:
sender: local:
EOF
# create map
rm -f ${ALIMAP}
${MM} < ${ALI}

# create mailertable (save old version?)
${CAT} > ${MT} <<EOF
local.dom	lmtp:
some.dom	[127.0.0.1]
EOF

# ----------------------------------------
# test: send mail to local address, check Return-Path:, VERP turned on
TEST=1
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

# ----------------------------------------
${CAT} > ${SMXCNF} <<EOF
qmgr { Log_Level = 12; wait_for_server=4; wait_for_client=4;
VERP { when=always; add= {IID, ~rcpt} }
}
smar {
Log_Level = 12;
nameserver = ${NS};
DNS_timeout = 5;
}
smtpc { Log_Level = 12; remote_port=${SNKPORT}; wait_for_server=4; }
smtps {
Log_Level = 14;
daemon_address = localhost:${SRVPORT};
wait_for_server=4;
}
EOF

if ${SHELL} ${SD}/smtpcnf.sh -Z "smtpc2" -3 lmtpsock -Ssender@some.dom -Ruser@local.dom -E 0 -X 0 -A 1 -c '-M IID=InJectiOn21'
then
  if test -s ${B1}
  then
    if ${GREP} '^Return-Path: <sender=InJectiOn21@some.dom>' ${B1} >/dev/null
    then
      :
    else
      echo "$0: ${TEST}: ERROR: found wrong Return-Path in ${B1}"
      ERR=true
    fi
  else
    echo "$0: ${TEST}: ERROR: ${B1} not found"
    ERR=true
  fi
  if test -s ${B2}
  then
    echo "$0: ${TEST}: ERROR: ${B2} found"
    ERR=true
  fi
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


rm -f ${MTMAP} ${ALIMAP}
# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
