#!/bin/sh
# $Id: t-dns-0.sh,v 1.19 2014/04/15 16:14:58 ca Exp $
# Copyright (c) 2003-2006 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# run t-dnstsk-0 and t-dnstsk-1 with various parameters/arguments.
# ----------------------------------------
#

# ??? only for meta1.org tests?
#if test X"${MTA_NO_DNS_TEST}" != "X"
#then
#  echo "SKIPPED: $0"
#  exit 0
#fi

#
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../
fi
. ${SD}/common.sh

TPRG=./t-dnstsk-0
rm -f $OUT

# Hack... need an IP address which does not respond to DNS
NN="127.1.2.3"

# some domains to test
DOMAINS="aol.com esmtp.org"
for i in ${DOMAINS}
do
  # check the output?
  ${TPRG} "$@" -i ${NS} ${i} || exit 1
done

if ${TPRG} -C 2>&1 | grep MTA_NETINET6 >/dev/null
then
# some domains to test
T="ipv6-1.meta1.org;fec0:0:0:0:2fd:87fe:1e72:1d4f ipv6-2.meta1.org;fec0:0:2:3:2c4:f0af:f948:efae"
for i in ${T}
do
  D=`echo $i | cut -d';' -f1`
  R=`echo $i | cut -d';' -f2`
  if ${TPRG} "$@" -i ${NS} -AmV ${D} > ${OUT}
  then
    :
  else
    echo "$0: test failed for $i"
    exit 1
  fi
  if grep $R ${OUT} >/dev/null
  then
    :
  else
    echo "$0: did not find $R in ${OUT}"
    exit 1
  fi
done
fi

# use second DNS test program
if ./t-dnstsk-1 "$@" -i ${NS} ${DOMAINS}
then
  :
else
  echo "$0: test failed for ${DOMAINS}"
  exit 1
fi

# trigger timeout?
if ./t-dnstsk-1 "$@" -t 5000 -i ${NN} ${DOMAINS}
then
  :
else
  echo "$0: test (timeout) failed for ${DOMAINS}"
  exit 1
fi

rm -f $OUT
exit 0
