/*
 *
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: validxtext.c,v 1.2 2008/11/18 03:30:58 ca Exp $")
#include "sm/error.h"
#include "sm/ctype.h"
#include "sm/str.h"
#include "sm/misc.h"

/*
**  VALIDXTEXT -- check whether str is "xtext"
**
**	Parameters:
**		str -- text to check.
**
**	Returns:
**		true iff text is xtext
*/

bool
validxtext(sm_str_P str)
{
	uchar c;
	uint i, str_len;

	if (NULL == str)
		return true;

	str_len = sm_str_getlen(str);
	i = 0;
	while (i < str_len) {
		c = sm_str_rd_elem(str, i);
		if (c == '+') {
			if (i + 2 >= str_len)
				return false;
			++i;
			c = sm_str_rd_elem(str, i);
			if (!ISXDIGIT(c))
				return false;
			++i;
			c = sm_str_rd_elem(str, i);
			if (!ISXDIGIT(c))
				return false;
		}
		else if (c < (uchar)'!' || c > (uchar)'~' || c == (uchar)'=')
			return false;
		++i;
	}
	return true;
}
