#!/bin/sh
# $Id: t-mm-fail-0.sh,v 1.2 2008/01/19 06:39:08 ca Exp $
#
# ------------------------------------------------------------
# Description:
# Script to check t-mm failure handling
# ------------------------------------------------------------

test -s stop && exit 1
#

BDBIN="crtm"
BDB="crtm.db"
ERRS=0
PRG=./t-mm

cat > ${BDBIN} <<EOF
a		rhs1
a		rhs2
EOF

MAPTYPES="`${PRG} -l 0 2>/dev/null`"
for maptype in ${MAPTYPES}
do

# create map
rm -f ${BDB}
# this program should generate an error, let's redirect stderr to
# avoid confusing a user...
${PRG} -u -t'	' -T ${maptype} -F ${BDB} < ${BDBIN} 2>/dev/null
if test $? != 0
then
  if test -f ${BDB}
  then
    ERRS=`expr ${ERRS} + 1 `
  fi
else
  ERRS=`expr ${ERRS} + 1 `
fi

done

rm -f ${BDBIN}

exit ${ERRS}
