#!/bin/sh
# $Id: t-sockmap-0.sh,v 1.5 2009/07/27 03:19:51 ca Exp $
# Copyright (c) 2004 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# Test for socketmap.
# Uses
# perl (how to find that?)
# t-sockmapsrv.pl
# t-sockmapr-0
# ----------------------------------------
#
test -s stop && exit 1
#

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../libsmmap
fi

ERRS=0
SOCKSRV=${SD}/t-sockmapsrv.pl
PIDS=pids
PRG=./t-sockmapr-0
V=""

# works only with ksh on OSF/1
if test X"`uname`" != "XOSF1"
then
while getopts v FLAG
do
  case "${FLAG}" in
    v) VERBOSE=true
	V="-v"
	;;
    ?)
       echo "$0: unknown option ${FLAG}"
       echo "usage: $0 [options]"
       echo "$0: options:"
       echo "-v     verbose"
       exit 1
       ;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

killit()
{
if test -s ${PIDS}
then
  for i in `cat ${PIDS}`
  do
    kill ${i}
  done
fi
}
trap killit 2 15

if test -x ${SOCKSRV}
then
  # XREF: port in ${PRG}
  perl ${SOCKSRV} $V tcp:127.0.0.1:1289 &
  echo $! > ${PIDS}
  sleep 3

  for args in "" "-N nomore"
  do
    if ${PRG} ${args}
    then
      :
    else
      $VERBOSE && echo "$0: ${PRG} ${args} failed"
      ERRS=`expr ${ERRS} + 1`
    fi
  done

  for i in `cat ${PIDS}`
  do
    kill ${i}
  done
  rm -f ${PIDS}
else
  echo $0: ${SOCKSRV} not found
  exit 1
fi
exit ${ERRS}
