#!/bin/sh
# $Id: t-restart-dep-2.sh,v 1.6 2013/12/22 15:19:48 ca Exp $
#
# Copyright (c) 2011 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test restart functionality of mcp: restart "server" process too
# and its dependencies
# ----------------------------------------

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../mcp
fi
L1=qmgr.log
L2=smtps.log
L3=smtpc.log
. ${SD}/common.sh

N=5
cat > ${CONF} <<EOF
qmgr {
	start_action = wait; processes_min = 1; processes_max = 1;
	user = ${USER};
	restart_dependencies = {smtps,smtpc};
	path = ./t-restart;
	arguments = "t-restart -p ${PIDF1} -f ${R1} -n ${N} -VV";
}
smtps {
	start_action = wait; processes_min = 1; processes_max = 1;
	user = ${USER};
	path = ./t-restart;
	arguments = "t-restart -p ${PIDF2} -f ${R2} -n ${N} -VV -Ro -s 2";
}
smtpc {
	start_action = wait; processes_min = 1; processes_max = 1;
	user = ${USER};
	path = ./t-restart;
	arguments = "t-restart -p ${PIDF3} -f ${R3} -n ${N} -VV";
}
EOF

echo 0 > ${R1}
echo 0 > ${R2}
echo 0 > ${R3}
./mcp -D -t -dddd ${CONF} > ${OUT} 2>&1 &
echo $! >> ${PIDS}

waitforfile ${PIDF1}
waitforfile ${PIDF2}

i=0
while test ${i} -le 2
do
  if grep 'asked' ${OUT} >/dev/null
  then
     break
  fi
  sleep 3
  i=`expr ${i} + 1 `
done

# give it time to restart
sleep 3

CNT=2
for F in ${R1} ${R2} ${R2}
do
if test -s ${F}
then
  C=`cat ${F}`
  if test ${C} -ne ${CNT}
  then
    ${VERBOSE} && echo "counter ${F} wrong: got ${C}, expected ${CNT}"
    ERRS=`expr ${ERRS} + 1 `
  fi
else
  ${VERBOSE} && echo "missing ${F}"
  ERRS=`expr ${ERRS} + 1 `
fi
done

stopit
testend
