#!/bin/sh
# $Id: t-conf-0.sh,v 1.2 2011/05/02 17:58:35 ca Exp $
# Copyright (c) 2011 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.

# ---------------------------
# invoke qmgr to print some configuration files, check return codes
# ---------------------------

test -s stop && exit 1              

PRG=./qmgr
T=`basename $0 .sh`
CONF=${T}.conf
OUT=${T}.out
ERR=0

runtest()
{
  EEC=$1

  $PRG -f ${CONF} -VVVV >${OUT} 2>&1
  EC=$?
  if [ ${EC} -ne ${EEC} ]
  then
    echo "$0: exit code=${EC}, expected=${EEC}"
    ERR=1
    return 1
  fi
  return 0
}

# ---------------------------
# empty config file: ok...
TEST=1
rm -f ${CONF} ${OUT}
cat > ${CONF} <<EOF
qmgr { }
EOF
runtest 0

# ---------------------------
# broken config file
TEST=2
rm -f ${CONF} ${OUT}
cat > ${CONF} <<EOF
qmgr { bogus_option=1; }
EOF
runtest 78

rm -f ${CONF} ${OUT}

exit $ERR
