#!/bin/sh
# $Id: t-rcptcnf-2.sh,v 1.2 2014/05/31 16:42:13 ca Exp $
#
# ------------------------------------------------------------
# Description:
# Script to test smtpc_rcpt_conf
# ------------------------------------------------------------

TPRG=./t-smar-1
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../smar
fi
. ${SD}/common.sh

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

chkcto MTA_TEST_MAP

CONF=smar.conf
${CAT} > ${CONF} <<EOF
smar {
  map acc { type=tst; }
  access_map { name=acc;}
}
EOF

rm -f ${ACCMAP} ${SOCK} ${PIDS} ${MT}

trap killit 2

# start SMAR
${SHELL} ${SD}/startsmar.sh -f ${CONF} -d 9 ${SMAROPTS} || exit 1
rm -f ${OUT} ${IP} ${OK}

TEST=1
# ----------------------------------------
if echo "${SKIP} X" | grep -v ' '${TEST}' ' > /dev/null
then
${VALGRIND} ${TPRG} -c '<m4@example.com>' > ${OUT} 2>&1
grep '^react=' ${OUT} > ${IP}
cat > ${OK} <<EOF
react=smtpc_rcpt_conf, ret=0, resconf=0x8c030114
react=smtpc_rcpt_conf, ret=0, rhsconf=''
EOF
if diff ${OK} ${IP}
then
  :
else
  ERRS=`expr ${ERRS} + 1 `
  echo "$0: test ${TEST} failed."
  test X"${MTA_STOPONERROR}" != X && exit ${ERRS}
fi
fi

TEST=2
# ----------------------------------------
if echo "${SKIP} X" | grep -v ' '${TEST}' ' > /dev/null
then
${VALGRIND} ${TPRG} -c '<mn@example.com>' '<mn@example.com>' > ${OUT} 2>&1
grep '^react=' ${OUT} > ${IP}
cat > ${OK} <<EOF
react=smtpc_rcpt_conf, ret=0, resconf=0x8c030114
react=smtpc_rcpt_conf, ret=0, rhsconf=''
react=smtpc_rcpt_conf, ret=0, resconf=0x8c040108
react=smtpc_rcpt_conf, ret=0, rhsconf=''
EOF
if diff ${OK} ${IP}
then
  :
else
  ERRS=`expr ${ERRS} + 1 `
  echo "$0: test ${TEST} failed."
  test X"${MTA_STOPONERROR}" != X && exit ${ERRS}
fi
fi


# ----------------
# stop SMAR
for i in `cat ${PIDS}`
do
  kill ${i}
done
# ----------------
# thanks kids for not following the POSIX standard...
if test X"`uname`" = "XLinux"
then
  killall smar
fi
sleep 3

[ ${ERRS} -eq 0 ] && rm -f ${OUT} ${IP} ${OK}
exit ${ERRS}
